﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace MathExercise1
{
    public class World
    {
        protected Game1 game;

        public Player Player1 { get; set; }
        public ProjectileManager Projectiles { get; set; }
        public int WorldWidth { get; set; }
        public int WorldHeight { get; set; }

        public World(Game1 containingGame, int w, int h)
        {
            game = containingGame;
            Player1 = new Player(this);
            Projectiles = new ProjectileManager(this);
            WorldWidth = w;
            WorldHeight = h;
        }
        public void LoadContent(ContentManager content)
        {
            Player1.LoadContent(content);
            Projectiles.LoadContent(content);
        }

        public void Update(GameTime gameTime)
        {
            Projectiles.Update(gameTime);

            Player1.Update(gameTime);
            if (Player1.Velocity.LengthSquared() > Player1.Max_Speed_Squared)
            {
                Player1.Velocity.Normalize();
                Player1.Velocity = Vector2.Normalize(Player1.Velocity) * Player1.Max_Speed;
            }

            Player1.Position += Player1.Velocity * (float)gameTime.ElapsedGameTime.TotalSeconds;


            if (Player1.Position.X < 0)
            {
                Player1.Position = new Vector2(0, Player1.Position.Y);
                Player1.Velocity= new Vector2(1 - Player1.Velocity.X, Player1.Velocity.Y);
            }
            if (Player1.Position.X >  WorldWidth)
            {
                Player1.Position = new Vector2(WorldWidth, Player1.Position.Y);
                Player1.Velocity = new Vector2(1 - Player1.Velocity.X, Player1.Velocity.Y);
            }
            if (Player1.Position.Y < 0)
            {
                Player1.Position = new Vector2(Player1.Position.X, 0);
                Player1.Velocity = new Vector2(Player1.Velocity.X, 1 - Player1.Velocity.Y);
            }
            if (Player1.Position.Y > WorldHeight)
            {
                Player1.Position = new Vector2(Player1.Position.X, WorldHeight);
                Player1.Velocity = new Vector2(Player1.Velocity.X, 1 - Player1.Velocity.Y);
            }

        }

        public void Draw(SpriteBatch sb)
        {
            Player1.Draw(sb);
            Projectiles.Draw(sb);
        }
    }
}
